--- old/exception_lists/packaging	Mon Nov  6 02:54:31 2017
+++ new/exception_lists/packaging	Mon Nov  6 02:54:31 2017
@@ -26,6 +26,7 @@
 # Copyright 2016 Hans Rosenfeld <rosenfeld@grumpf.hope-2000.org>
 # Copyright 2016 Nexenta Systems, Inc.
 # Copyright 2017 Toomas Soome <tsoome@me.com>
+# Copyright 2017 RackTop Systems.
 #
 
 #
@@ -723,19 +724,19 @@
 usr/include/smb
 usr/include/smbsrv
 #
-# Private/Internal libraries for smbsrv in user space
+# Private/Internal files for libfakekernel. Do not ship.
 #
+lib/amd64/libfakekernel.so			i386
+lib/amd64/llib-lfakekernel.ln			i386
+lib/sparcv9/libfakekernel.so			sparc
+lib/sparcv9/llib-lfakekernel.ln			sparc
+lib/libfakekernel.so
+lib/llib-lfakekernel
+lib/llib-lfakekernel.ln
 usr/include/libfakekernel
 usr/lib/libfakekernel.so
-usr/lib/libfakekernel.so.1
-usr/lib/llib-lfakekernel
-usr/lib/llib-lfakekernel.ln
-usr/lib/amd64/llib-lfakekernel.ln		i386
-usr/lib/sparcv9/llib-lfakekernel.ln		sparc
 usr/lib/amd64/libfakekernel.so			i386
-usr/lib/amd64/libfakekernel.so.1		i386
 usr/lib/sparcv9/libfakekernel.so		sparc
-usr/lib/sparcv9/libfakekernel.so.1		sparc
 #
 # Private/Internal libraries of smbsrv. Do not ship.
 #
--- old/usr/src/Targetdirs	Mon Nov  6 02:54:31 2017
+++ new/usr/src/Targetdirs	Mon Nov  6 02:54:31 2017
@@ -24,10 +24,10 @@
 # Copyright (c) 2012 by Delphix. All rights reserved.
 # Copyright (c) 2012, Igor Kozhukhov <ikozhukhov@gmail.com>
 # Copyright 2012 OmniTI Computer Consulting, Inc.  All rights reserved.
-# Copyright (c) 2013 RackTop Systems.
 # Copyright 2014 Garrett D'Amore <garrett@damore.org>
 # Copyright 2016 Hans Rosenfeld <rosenfeld@grumpf.hope-2000.org>
 # Copyright 2016 Nexenta Systems, Inc.
+# Copyright 2017 RackTop Systems.
 #
 
 #
@@ -849,6 +849,8 @@
 $(ROOT)/usr/lib/libefi.so:=		REALPATH=../../lib/libefi.so.1
 $(ROOT)/usr/lib/libelf.so.1:=		REALPATH=../../lib/libelf.so.1
 $(ROOT)/usr/lib/libelf.so:=		REALPATH=../../lib/libelf.so.1
+$(ROOT)/usr/lib/libfakekernel.so.1:=	REALPATH=../../lib/libfakekernel.so.1
+$(ROOT)/usr/lib/libfakekernel.so:=	REALPATH=../../lib/libfakekernel.so.1
 $(ROOT)/usr/lib/libfdisk.so.1:=		REALPATH=../../lib/libfdisk.so.1
 $(ROOT)/usr/lib/libfdisk.so:=		REALPATH=../../lib/libfdisk.so.1
 $(ROOT)/usr/lib/libgen.so.1:=		REALPATH=../../lib/libgen.so.1
@@ -1306,6 +1308,10 @@
 	REALPATH=../../../lib/$(MACH64)/libzfs_core.so.1
 $(ROOT)/usr/lib/$(MACH64)/libzfs_core.so.1:= \
 	REALPATH=../../../lib/$(MACH64)/libzfs_core.so.1
+$(ROOT)/usr/lib/$(MACH64)/libfakekernel.so:= \
+	REALPATH=../../../lib/$(MACH64)/libfakekernel.so.1
+$(ROOT)/usr/lib/$(MACH64)/libfakekernel.so.1:= \
+	REALPATH=../../../lib/$(MACH64)/libfakekernel.so.1
 $(ROOT)/usr/lib/$(MACH64)/libfdisk.so.1:= \
 	REALPATH=../../../lib/$(MACH64)/libfdisk.so.1
 $(ROOT)/usr/lib/$(MACH64)/libfdisk.so:= \
@@ -1482,6 +1488,8 @@
 	/usr/lib/libefi.so.1 \
 	/usr/lib/libelf.so \
 	/usr/lib/libelf.so.1 \
+	/usr/lib/libfakekernel.so \
+	/usr/lib/libfakekernel.so.1 \
 	/usr/lib/libgen.so \
 	/usr/lib/libgen.so.1 \
 	/usr/lib/libinetutil.so \
@@ -1731,6 +1739,8 @@
 	/usr/lib/$(MACH64)/libefi.so.1 \
 	/usr/lib/$(MACH64)/libelf.so \
 	/usr/lib/$(MACH64)/libelf.so.1 \
+	/usr/lib/$(MACH64)/libfakekernel.so \
+	/usr/lib/$(MACH64)/libfakekernel.so.1 \
 	/usr/lib/$(MACH64)/libgen.so \
 	/usr/lib/$(MACH64)/libgen.so.1 \
 	/usr/lib/$(MACH64)/libinetutil.so \
--- old/usr/src/cmd/mdb/intel/amd64/libzpool/Makefile	Mon Nov  6 02:54:31 2017
+++ new/usr/src/cmd/mdb/intel/amd64/libzpool/Makefile	Mon Nov  6 02:54:31 2017
@@ -23,6 +23,8 @@
 # Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
+# Copyright 2017 RackTop Systems.
+#
 
 MODULE = libzpool.so
 MDBTGT = proc
@@ -38,6 +40,7 @@
 MODSRCS_DIR = ../../../common/modules/zfs
 GENUNIX_DIR = ../../../common/modules/genunix
 
+CPPFLAGS.first = -I$(SRC)/lib/libfakekernel/common -D_FAKE_KERNEL
 CPPFLAGS += -I../../../../../lib/libzpool/common \
 	-I../../../../../uts/common/fs/zfs
 
--- old/usr/src/cmd/mdb/intel/ia32/libzpool/Makefile	Mon Nov  6 02:54:32 2017
+++ new/usr/src/cmd/mdb/intel/ia32/libzpool/Makefile	Mon Nov  6 02:54:32 2017
@@ -24,6 +24,7 @@
 # Use is subject to license terms.
 #
 # Copyright (c) 2016 by Delphix. All rights reserved.
+# Copyright 2017 RackTop Systems.
 #
 
 MODULE = libzpool.so
@@ -39,6 +40,7 @@
 MODSRCS_DIR = ../../../common/modules/zfs
 GENUNIX_DIR = ../../../common/modules/genunix
 
+CPPFLAGS.first = -I$(SRC)/lib/libfakekernel/common -D_FAKE_KERNEL
 CPPFLAGS += -I../../../../../lib/libzpool/common \
 	-I../../../../../uts/common/fs/zfs \
 	-I../../../../../uts/common/fs/zfs/lua
--- old/usr/src/cmd/zdb/Makefile.com	Mon Nov  6 02:54:32 2017
+++ new/usr/src/cmd/zdb/Makefile.com	Mon Nov  6 02:54:32 2017
@@ -24,6 +24,7 @@
 # Use is subject to license terms.
 # Copyright (c) 2012 by Delphix. All rights reserved.
 # Copyright 2017 Joyent, Inc.
+# Copyright 2017 RackTop Systems.
 #
 
 PROG:sh=	cd ..; basename `pwd`
@@ -37,7 +38,7 @@
 INCS +=	-I../../../uts/common/fs/zfs
 INCS +=	-I../../../common/zfs
 
-LDLIBS += -lzpool -lumem -lnvpair -lzfs -lavl -lcmdutils
+LDLIBS += -lzpool -lumem -lnvpair -lzfs -lavl -lcmdutils -lfakekernel
 
 C99MODE=	-xc99=%all
 C99LMODE=	-Xc99=%all
@@ -44,6 +45,7 @@
 
 CFLAGS += $(CCVERBOSE)
 CFLAGS64 += $(CCVERBOSE)
+CPPFLAGS.first = -I$(SRC)/lib/libfakekernel/common -D_FAKE_KERNEL
 CPPFLAGS += -D_LARGEFILE64_SOURCE=1 -D_REENTRANT $(INCS) -DDEBUG
 
 # re-enable warnings that we can tolerate, which are disabled by default
--- old/usr/src/cmd/zdb/zdb.c	Mon Nov  6 02:54:32 2017
+++ new/usr/src/cmd/zdb/zdb.c	Mon Nov  6 02:54:32 2017
@@ -24,6 +24,7 @@
  * Copyright (c) 2011, 2016 by Delphix. All rights reserved.
  * Copyright (c) 2014 Integros [integros.com]
  * Copyright 2017 Nexenta Systems, Inc.
+ * Copyright 2017 RackTop Systems.
  */
 
 #include <stdio.h>
@@ -94,6 +95,7 @@
 
 static const char cmdname[] = "zdb";
 uint8_t dump_opt[256];
+extern int aok;
 
 typedef void object_viewer_t(objset_t *, uint64_t, void *data, size_t size);
 
--- old/usr/src/cmd/zfs/zfs_main.c	Mon Nov  6 02:54:32 2017
+++ new/usr/src/cmd/zfs/zfs_main.c	Mon Nov  6 02:54:32 2017
@@ -60,6 +60,7 @@
 #include <sys/fs/zfs.h>
 #include <sys/types.h>
 #include <time.h>
+#include <synch.h>
 
 #include <libzfs.h>
 #include <libzfs_core.h>
@@ -5749,8 +5750,13 @@
 
 #define	CHECK_SPINNER 30
 #define	SPINNER_TIME 3		/* seconds */
-#define	MOUNT_TIME 5		/* seconds */
+#define	MOUNT_TIME 1		/* seconds */
 
+typedef struct get_all_state {
+	boolean_t	ga_verbose;
+	get_all_cb_t	*ga_cbp;
+} get_all_state_t;
+
 static int
 get_one_dataset(zfs_handle_t *zhp, void *data)
 {
@@ -5758,10 +5764,10 @@
 	static int spinval = 0;
 	static int spincheck = 0;
 	static time_t last_spin_time = (time_t)0;
-	get_all_cb_t *cbp = data;
+	get_all_state_t *state = data;
 	zfs_type_t type = zfs_get_type(zhp);
 
-	if (cbp->cb_verbose) {
+	if (state->ga_verbose) {
 		if (--spincheck < 0) {
 			time_t now = time(NULL);
 			if (last_spin_time + SPINNER_TIME < now) {
@@ -5787,26 +5793,24 @@
 		zfs_close(zhp);
 		return (0);
 	}
-	libzfs_add_handle(cbp, zhp);
-	assert(cbp->cb_used <= cbp->cb_alloc);
+	libzfs_add_handle(state->ga_cbp, zhp);
+	assert(state->ga_cbp->cb_used <= state->ga_cbp->cb_alloc);
 
 	return (0);
 }
 
 static void
-get_all_datasets(zfs_handle_t ***dslist, size_t *count, boolean_t verbose)
+get_all_datasets(get_all_cb_t *cbp, boolean_t verbose)
 {
-	get_all_cb_t cb = { 0 };
-	cb.cb_verbose = verbose;
-	cb.cb_getone = get_one_dataset;
+	get_all_state_t state = {
+	    .ga_verbose = verbose,
+	    .ga_cbp = cbp
+	};
 
 	if (verbose)
 		set_progress_header(gettext("Reading ZFS config"));
-	(void) zfs_iter_root(g_zfs, get_one_dataset, &cb);
+	(void) zfs_iter_root(g_zfs, get_one_dataset, &state);
 
-	*dslist = cb.cb_handles;
-	*count = cb.cb_used;
-
 	if (verbose)
 		finish_progress(gettext("done."));
 }
@@ -5816,9 +5820,20 @@
  * similar, we have a common function with an extra parameter to determine which
  * mode we are using.
  */
-#define	OP_SHARE	0x1
-#define	OP_MOUNT	0x2
+typedef enum { OP_SHARE, OP_MOUNT } share_mount_op_t;
 
+typedef struct share_mount_state {
+	share_mount_op_t sm_op;
+	boolean_t sm_verbose;
+	int	sm_flags;
+	char	*sm_options;
+	char	*sm_proto; /* only valid for OP_SHARE */
+	mutex_t	sm_lock; /* protects the remaining fields */
+	uint_t	sm_total; /* number of filesystems to process */
+	uint_t	sm_done; /* number of filesystems processed */
+	int	sm_status; /* -1 if any of the share/mount operations failed */
+} share_mount_state_t;
+
 /*
  * Share or mount a dataset.
  */
@@ -6059,6 +6074,29 @@
 		update_progress(info);
 }
 
+/*
+ * zfs_foreach_mountpoint() callback that mounts or shares one filesystem and
+ * updates the progress meter.
+ */
+static int
+share_mount_one_cb(zfs_handle_t *zhp, void *arg)
+{
+	share_mount_state_t *sms = arg;
+	int ret;
+
+	ret = share_mount_one(zhp, sms->sm_op, sms->sm_flags, sms->sm_proto,
+	    B_FALSE, sms->sm_options);
+
+	(void) mutex_lock(&sms->sm_lock);
+	if (ret != 0)
+		sms->sm_status = ret;
+	sms->sm_done++;
+	if (sms->sm_verbose)
+		report_mount_progress(sms->sm_done, sms->sm_total);
+	(void) mutex_unlock(&sms->sm_lock);
+	return (ret);
+}
+
 static void
 append_options(char *mntopts, char *newopts)
 {
@@ -6131,8 +6169,6 @@
 
 	/* check number of arguments */
 	if (do_all) {
-		zfs_handle_t **dslist = NULL;
-		size_t i, count = 0;
 		char *protocol = NULL;
 
 		if (op == OP_SHARE && argc > 0) {
@@ -6153,33 +6189,44 @@
 		}
 
 		start_progress_timer();
-		get_all_datasets(&dslist, &count, verbose);
+		get_all_cb_t cb = { 0 };
+		get_all_datasets(&cb, verbose);
 
-		if (count == 0)
+		if (cb.cb_used == 0)
 			return (0);
 
-		qsort(dslist, count, sizeof (void *), libzfs_dataset_cmp);
-		sa_init_selective_arg_t sharearg;
-		sharearg.zhandle_arr = dslist;
-		sharearg.zhandle_len = count;
-		if ((ret = zfs_init_libshare_arg(zfs_get_handle(dslist[0]),
-		    SA_INIT_SHARE_API_SELECTIVE, &sharearg)) != SA_OK) {
-			(void) fprintf(stderr,
-			    gettext("Could not initialize libshare, %d"), ret);
-			return (ret);
+		if (op == OP_SHARE) {
+			sa_init_selective_arg_t sharearg;
+			sharearg.zhandle_arr = cb.cb_handles;
+			sharearg.zhandle_len = cb.cb_used;
+			if ((ret = zfs_init_libshare_arg(g_zfs,
+			    SA_INIT_SHARE_API_SELECTIVE, &sharearg)) != SA_OK) {
+				(void) fprintf(stderr, gettext(
+				    "Could not initialize libshare, %d"), ret);
+				return (ret);
+			}
 		}
 
-		for (i = 0; i < count; i++) {
-			if (verbose)
-				report_mount_progress(i, count);
+		share_mount_state_t share_mount_state = { 0 };
+		share_mount_state.sm_op = op;
+		share_mount_state.sm_verbose = verbose;
+		share_mount_state.sm_flags = flags;
+		share_mount_state.sm_options = options;
+		share_mount_state.sm_proto = protocol;
+		share_mount_state.sm_total = cb.cb_used;
+		(void) mutex_init(&share_mount_state.sm_lock, USYNC_THREAD,
+		    NULL);
+		/*
+		 * libshare isn't mt-safe, so only do the operation in parallel
+		 * if we're mounting.
+		 */
+		zfs_foreach_mountpoint(g_zfs, cb.cb_handles, cb.cb_used,
+		    share_mount_one_cb, &share_mount_state, op == OP_MOUNT);
+		ret = share_mount_state.sm_status;
 
-			if (share_mount_one(dslist[i], op, flags, protocol,
-			    B_FALSE, options) != 0)
-				ret = 1;
-			zfs_close(dslist[i]);
-		}
-
-		free(dslist);
+		for (int i = 0; i < cb.cb_used; i++)
+			zfs_close(cb.cb_handles[i]);
+		free(cb.cb_handles);
 	} else if (argc == 0) {
 		struct mnttab entry;
 
--- old/usr/src/cmd/zhack/Makefile.com	Mon Nov  6 02:54:33 2017
+++ new/usr/src/cmd/zhack/Makefile.com	Mon Nov  6 02:54:33 2017
@@ -26,6 +26,7 @@
 
 #
 # Copyright (c) 2012, 2016 by Delphix. All rights reserved.
+# Copyright 2017 RackTop Systems.
 #
 
 PROG= zhack
@@ -47,6 +48,7 @@
 
 CFLAGS += $(CCVERBOSE)
 CFLAGS64 += $(CCVERBOSE)
+CPPFLAGS.first = -I$(SRC)/lib/libfakekernel/common -D_FAKE_KERNEL
 CPPFLAGS += -D_LARGEFILE64_SOURCE=1 -D_REENTRANT -DDEBUG $(INCS)
 
 LINTFLAGS += -erroff=E_STATIC_UNUSED
--- old/usr/src/cmd/zinject/Makefile.com	Mon Nov  6 02:54:33 2017
+++ new/usr/src/cmd/zinject/Makefile.com	Mon Nov  6 02:54:33 2017
@@ -23,6 +23,7 @@
 # Use is subject to license terms.
 #
 # Copyright (c) 2016 by Delphix. All rights reserved.
+# Copyright 2017 RackTop Systems.
 #
 
 PROG:sh=	cd ..; basename `pwd`
@@ -40,6 +41,7 @@
 C99MODE=	-xc99=%all
 C99LMODE=	-Xc99=%all
 
+CPPFLAGS.first = -I$(SRC)/lib/libfakekernel/common -D_FAKE_KERNEL
 CPPFLAGS += -D_LARGEFILE64_SOURCE=1 -D_REENTRANT $(INCS)
 
 CERRWARN += -_gcc=-Wno-uninitialized
--- old/usr/src/cmd/ztest/Makefile.com	Mon Nov  6 02:54:33 2017
+++ new/usr/src/cmd/ztest/Makefile.com	Mon Nov  6 02:54:33 2017
@@ -21,6 +21,7 @@
 #
 # Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
 # Copyright (c) 2012, 2016 by Delphix. All rights reserved.
+# Copyright 2017 RackTop Systems.
 #
 
 PROG= ztest
@@ -35,12 +36,13 @@
 INCS += -I../../../uts/common/fs/zfs/lua
 INCS += -I../../../common/zfs
 
-LDLIBS += -lumem -lzpool -lcmdutils -lm -lnvpair
+LDLIBS += -lumem -lzpool -lcmdutils -lm -lnvpair -lfakekernel
 
 C99MODE= -xc99=%all
 C99LMODE= -Xc99=%all
 CFLAGS += -g $(CCVERBOSE)
 CFLAGS64 += -g $(CCVERBOSE)
+CPPFLAGS.first = -I$(SRC)/lib/libfakekernel/common -D_FAKE_KERNEL
 CPPFLAGS += -D_LARGEFILE64_SOURCE=1 -D_REENTRANT $(INCS) -DDEBUG
 
 # lint complains about unused _umem_* functions
